@ECHO OFF
REM NAME: MULTI.BAT
REM PURPOSE: ISSUE MULTIPLE DOS COMMANDS ON A SINGLE LINE

IF (%1)==(/?) GOTO HELP
SET COMMAND=
IF (%1)==() GOTO HELP
IF (%1)==(^) GOTO HELP

:TOP
SET COMMAND=%COMMAND% %1
SHIFT
IF (%1)==() GOTO RUNLAST
IF (%1)==(^) GOTO RUN
GOTO TOP

:RUN
SHIFT
CALL %COMMAND%
SET COMMAND=
GOTO TOP

:RUNLAST
CALL %COMMAND%
GOTO END

:HELP
ECHO Runs multiple commands from a single line
ECHO -----------------------
ECHO The correct usage is:
ECHO MULTI command ^ command ^ command (etc.)
ECHO Separate each command with spaces and a caret ( ^ )

:END
SET COMMAND=
